#
# spec file for package zope (Version 2.7.7)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  python python-devel python-xml

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext libtool perl python python-devel python-xml rpm

Name:         zope
License:      Other License(s), see package
Summary:      Open Source Web Application Server
Group:        Productivity/Networking/Web/Frontends
Prereq:       /usr/sbin/useradd /usr/sbin/usermod /usr/sbin/groupadd
Requires:     python python-xml
Obsoletes:    zope-doc
Autoreqprov:  on
Version:      2.7.7
Release:      0.6
Source:       Zope-%{version}-final.tar.bz2
# SUSE specific things:
Source1:      zope.logrotate
Source2:      zope.init
Source3:      zope.sysconfig
Source4:      zope.mkzopeinstance
Source5:      zope.zpasswd
Source6:      zope.conf.in
Source10:     README.SUSE
# Patches
Patch0:       Zope-2.7.0-nosymlink.patch
Patch1:       Zope-2.7.0-mkinstance.patch
Patch2:       Zope-2.7.0-effective-user.patch
Patch5:       Zope-2.7.3-python2.4.patch 
Patch6:       Zope-2.7.4-no-whrandom-warning.patch
Patch7:       Zope-2.7.7-final-Hotfix_2005-10-09.patch
URL:          http://www.zope.org/
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The Z Object Programming Environment (Zope) enables teams to
collaborate in the creation and management of dynamic web-based
business applications such as intranets and portals. Zope makes it easy
to build features such as site search, news, personalization, and
e-commerce into your web applications.

Check http://www.zope.org for documentation, news, downloads, and more.

Read /usr/share/doc/packages/zope/README.SuSE for post installation
hints.

Check http://www.zope.org/Products for available products and save some
time.

If you want to use MySQL with Zope install zope-mysql.



Authors:
--------
    Jeff Bauer <jeffbauer@bigfoot.com>
    Sam Rushing <rushing@nightmare.com>

%prep
%setup -q -n Zope-%{version}-final
%patch0
%patch1
%patch2
%patch5
%patch6 -p1
%patch7 -p1
# documentation
cp %{S:10} .

%build
# configure
./configure --prefix=/opt/zope
# build
make

%install
# cleanup
rm -rf $RPM_BUILD_ROOT
# create python symlink, zope wants it
install -m 755 -d $RPM_BUILD_ROOT/opt/zope/bin/
ln -s /usr/bin/python $RPM_BUILD_ROOT/opt/zope/bin/python
# install main part
make install INSTALL_FLAGS="--root=$RPM_BUILD_ROOT"
# remove documentation
rm -rf $RPM_BUILD_ROOT/opt/zope/doc
rm -f $RPM_BUILD_ROOT/opt/zope/bin/README.txt
# sysconfig
install -m 755 -d $RPM_BUILD_ROOT/var/adm/fillup-templates
install -m 644 %{S:3} $RPM_BUILD_ROOT/var/adm/fillup-templates/sysconfig.zope
# init script
install -m 755 -d $RPM_BUILD_ROOT/etc/init.d
install -m 755 %{S:2} $RPM_BUILD_ROOT/etc/init.d/zope
install -m 755 -d $RPM_BUILD_ROOT/usr/sbin
ln -s /etc/init.d/zope $RPM_BUILD_ROOT/usr/sbin/rczope
# administration scripts
install -m 755 %{S:4} $RPM_BUILD_ROOT/usr/sbin/mkzopeinstance
install -m 755 %{S:5} $RPM_BUILD_ROOT/usr/sbin/zpasswd
# logrotate
install -m 755 -d $RPM_BUILD_ROOT/etc/logrotate.d
install -m 644 %{S:1} $RPM_BUILD_ROOT/etc/logrotate.d/zope
# zope instances home
install -m 755 -d $RPM_BUILD_ROOT/var/opt/zope
# some other needed stuff
install -m 755 -d $RPM_BUILD_ROOT/opt/zope/share
install -m 644 %{S:6} $RPM_BUILD_ROOT/opt/zope/share
# this won't run on windows...
rm -f $RPM_BUILD_ROOT/opt/zope/skel/bin/{runzope.bat.in,zopeservice.py.in}

%clean
rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -r zope 2> /dev/null ||:
/usr/sbin/useradd -r -o -g zope -u 64 -s /bin/false -c "Zope" -d /opt/zope zope 2> /dev/null || :
/usr/sbin/usermod -g zope zope 2>/dev/null ||: # in the past, it had daemon as initial group
/usr/sbin/usermod -d /opt/zope zope
%{save_rc_config_d_was_in_filelist}

%post
%{fillup_and_insserv zope}
# Create default instance
if [ ! -d /var/opt/zope/default ] ; then
    echo "Default zope instance not found, creating"
    /opt/zope/bin/mkzopeinstance.py \
        -d default \
        -u superuser:123
    cp /opt/zope/share/zope.conf.in /var/opt/zope/default/etc/
fi
# Update from 2.6 to 2.7 lead to orphaned Data.fs files, move them to new location.
if [ ${1:-0} -gt 1 ]; then
    # Does exist data?
    if [ -f opt/zope/var/Data.fs* -a ! -f var/opt/zope/default/var/Data.fs ] ; then
        mv -f opt/zope/var/Data.fs* var/opt/zope/default/var/
    fi
fi

%preun
%stop_on_removal zope

%postun
%restart_on_update zope
%insserv_cleanup

%files
%defattr(-, root, root)
%config /etc/init.d/zope
%config(noreplace) /etc/logrotate.d/zope
%dir /opt/zope
%dir /opt/zope/skel
%dir /opt/zope/bin
%defattr(755, root, root, 755)
/usr/sbin/*
/opt/zope/bin/*.py
/opt/zope/skel/bin
%defattr(644, root, root, 755)
/var/adm/fillup-templates/sysconfig.zope
%dir /var/opt/zope
/opt/zope/import
/opt/zope/lib
/opt/zope/share
/opt/zope/skel/Extensions
/opt/zope/skel/Products
/opt/zope/skel/etc
/opt/zope/skel/import
/opt/zope/skel/log
/opt/zope/skel/var
/opt/zope/skel/README.txt
%doc doc/*.txt doc/ZEO README.SUSE

%changelog -n zope
* Mon Oct 31 2005 - mkudlvasr@suse.cz
- applied Hotfix_2005-10-09 from zope.org (bug #130477)
* Wed Jul 13 2005 - mkudlvasr@suse.cz
- update to 2.7.7
* Thu Jun 09 2005 - mkudlvasr@suse.cz
- accepting changes since Mar 29 2004 + testing on sles9
* Tue May 10 2005 - mcihar@suse.cz
- update to 2.7.6
- regenerate patches
* Wed Apr 06 2005 - mcihar@suse.cz
- accept python 2.4.1
* Tue Mar 15 2005 - mcihar@suse.cz
- allow symlinks in /var/opt/zope
* Tue Jan 25 2005 - mcihar@suse.cz
- let's ignore warnings about whrandom module (bug #49994)
* Mon Jan 24 2005 - mcihar@suse.cz
- update to 2.7.4
* Wed Jan 19 2005 - mcihar@suse.cz
- fix warning about find parameters in init script (bug #49995)
* Thu Dec 09 2004 - mcihar@suse.cz
- actually implement logrotate parameter in initscript (bug #49078)
* Tue Nov 30 2004 - mcihar@suse.cz
- accept 2.4 final
* Thu Nov 25 2004 - mcihar@suse.cz
- let's accept python 2.4, needs more testing whether it will be okay
* Fri Oct 29 2004 - joe@suse.de
- update to 2.7.3. The SessionDataManager is not needed any more.
* Fri Sep 10 2004 - joe@suse.de
- patched SessionDataManager.py to solve a problem with
  sessions and high load (see http://zope.org/Collectors/Zope/1401)
* Mon Sep 06 2004 - mcihar@suse.cz
- fixed mkzopeinstance script (bugs #44729 and #44728)
* Wed Sep 01 2004 - mcihar@suse.cz
- drop update message and move Data.fs to new location, in most cases
  this works fine (bug #44353)
* Tue Aug 03 2004 - mcihar@suse.cz
- update to 2.7.2
* Tue Jun 22 2004 - mcihar@suse.cz
- update to 2.7.1
* Fri Jun 04 2004 - ro@suse.de
- remove apache from neededforbuild
- accept python-2.3.4 in configure
* Mon Mar 29 2004 - mcihar@suse.cz
- do not block SIGCHLD as zopectl needs to know how its child ended (bug #37108)
* Fri Mar 26 2004 - mcihar@suse.cz
- fixed rczope status to really return status
- improved output from init script
* Mon Mar 22 2004 - mcihar@suse.cz
- fix typo in patch
* Mon Mar 22 2004 - mcihar@suse.cz
- fix tuple parsing in initgroups (fixes bug #36072)
* Thu Mar 18 2004 - mcihar@suse.cz
- remove README.txt from /opt/zope/bin (bug #36332)
* Tue Mar 16 2004 - mcihar@suse.cz
- replace also empty variables in template
* Mon Mar 08 2004 - mcihar@suse.cz
- fixed permissions
- remove some scripts for windows
* Mon Mar 08 2004 - mcihar@suse.cz
- drop The Zope Book as it is not available for download now
- move remaining documentation to zope package
- add zpasswd script for creating init/access users
- support for sysconfig managed default instance
- mkzopeinstance places instaces into /var/opt/zope by default
- updated README.SUSE
* Tue Mar 02 2004 - mcihar@suse.cz
- update to 2.7.0
- now uses python 2.3, so no need for older one
- no root for build
- support for multiple instances
- data moved to /var/opt/zope
* Fri Jan 09 2004 - mcihar@suse.cz
- updated to 2.6.3
* Tue Dec 30 2003 - poeml@suse.de
- make the "inituser" file readable for the zope user, so the
  initial login can work (it failed since zope is no longer started
  as root) [#33683]. Package it with "missingok" in the file list.
- change zpasswd.py to set a secure filemask and ownership
  (Zope-2.6.2-src.zpasswd.dif)
- allow zpasswd to be used to create an emergency user ("zpasswd
  access")
- add a note to README.SuSE about zpasswd
- create an initial group "zope" for the zope user, so no files are
  shared with other daemons in group "daemon". Package the
  $ZOPE_HOME/var directory with 750 permissions.
- implement a "logrotate" target in the init script, so logrotate
  can work (there is no "reload")
- don't include the empty database (Data.fs) in the filelist, as
  it is created on the fly upon the first start
- don't create the log file symlink in %%post -- just package it
- don't %%clean if building in the chroot buildsystem
* Wed Dec 10 2003 - mcihar@suse.cz
- updated Zope Book to 2.6 version
* Wed Dec 10 2003 - poeml@suse.de
- update to stable release 2.6.2
- fix failing restarts (by waiting until the server is terminated)
- start zope with recommended umask 077 to improve security
* Thu Sep 04 2003 - mcihar@suse.cz
- default options in sysconfig metadata now equals real default values
* Mon Sep 01 2003 - mcihar@suse.cz
- remove feedback@suse.de
* Tue Aug 26 2003 - mcihar@suse.cz
- don not remove empty logfiles (bug #29368)
* Thu Aug 14 2003 - mcihar@suse.cz
- added activation metadata to sysconfig templates (bug #28833 and #28966)
* Mon Aug 11 2003 - mcihar@suse.cz
- do not include log files in rpm (touch them if they don't exist in
  post, remove them if empty in postun)
* Thu Aug 07 2003 - mcihar@suse.cz
- merged Deutsche Zope User Group (www.dzug.org) changes:
- much more sysconfig settings
- no more absolute path in init script (closes bug #27291)
- spec file cleanup
* Sat Aug 02 2003 - poeml@suse.de
- fix doubled Source10
* Thu Jul 31 2003 - poeml@suse.de
- mark /var/log/zope.log %%config(noreplace), and make it
  non-readable for the world
- add logrotate snippet
- new macros for stop/restart of services on rpm update/removal
- fix build by removing (unused) .o files from the buildroot
* Mon May 19 2003 - mcihar@suse.cz
- remove .cvsignore files
* Thu May 15 2003 - mcihar@suse.cz
- cleaned up specfile
- fixed permissions
* Tue May 13 2003 - mcihar@suse.cz
- don't include files used for build
* Wed Feb 26 2003 - mcihar@suse.cz
- don't include temporary files from build
- fixed permissions to /opt/zope/var (now allows packing of database)
* Thu Feb 20 2003 - mcihar@suse.cz
- make sysconfig comments more accurate and better fit in sysconfig
  editor
* Mon Feb 10 2003 - mcihar@suse.cz
- updated to 2.6.1:
  * Catlog changes to speed sorting and lower memory consumption
  * ZODB Deadlock avoidance, fixed store order
  * BTree based indexes for FileStorage
  * Fixes for the rfc822 timezone / locale bugs in Zope 2.6.0
* Mon Jan 06 2003 - mcihar@suse.cz
- added metadata into sysconfig templates (fixes #22610 and #22708)
* Fri Nov 29 2002 - mcihar@suse.cz
- removed dependency on /var/tmp/zope-2.6.0-build/opt/zope/pcgi/pcgi-wrapper
* Mon Nov 18 2002 - mcihar@suse.cz
- do not use /opt/zope/lib64 on 64-bit arches, as it seems to be useless and
  only causes problems
* Wed Oct 30 2002 - mcihar@suse.cz
- correct paths in /opt/zope/Zope.cgi (bug #21331)
* Fri Oct 25 2002 - mcihar@suse.cz
- updated to 2.6.0
- uses buildroot
* Sat Jul 27 2002 - adrian@suse.de
- fix init script
* Mon Jun 24 2002 - ro@suse.de
- fixed permissions for doc directories
* Mon Jun 10 2002 - vinil@suse.cz
- use python2.1
- get rid of obsolete documentation
* Wed Jun 05 2002 - vinil@suse.cz
- new version 2.5.1
- documentation (ZopeBook) updated
- zope user is created in pre-install, now
- zope's home changed to /opt/zope
* Mon Jun 03 2002 - stepan@suse.de
- %%_lib fixes
* Mon Mar 04 2002 - vinil@suse.cz
- added security patch: Hotfix_2002-03-01
* Wed Feb 20 2002 - vinil@suse.cz
- documentation (ZopeBook) updated
* Mon Jan 28 2002 - vinil@suse.cz
- new version 2.5.0
* Fri Jan 25 2002 - vinil@suse.cz
- moved rc.config vars -> sysconfig/apache
- new version 2.4.3
* Thu Dec 13 2001 - ro@suse.de
- save rc.config.d file which erroneously was in filelist before
* Wed Dec 12 2001 - ro@suse.de
- removed START_ZOPE, moved rc.config.d -> sysconfig
* Wed Sep 05 2001 - vinil@suse.cz
- new version 2.4.1 -> get rid of hotfixes
* Sun Aug 26 2001 - vinil@suse.cz
- security Hotfix_2001-07-25 added
* Thu Aug 16 2001 - vinil@suse.cz
- new version 2.4.0
- security Hotfix 2001_08_04 added
- ZopeBook and DevGuide updated
* Tue Jul 24 2001 - vinil@suse.cz
- use included build system (farewell buildroot)
- import bug fixed
* Thu Jul 12 2001 - vinil@suse.cz
- got rid of redirections in rc script
- "[SuSE Linux]" appended to version string
* Tue Jul 03 2001 - vinil@suse.cz
- unused required removed
- typo in rczope script fixed
* Tue Jul 03 2001 - vinil@suse.cz
- version 2.3.3
- package completely remade (zope lives in /opt/zope, now)
- zope-doc, zope-doc-pdf now exists
* Wed May 16 2001 - pblaha@suse.cz
- add  /etc/httpd/modules/zope for fix bug #8446
* Tue May 15 2001 - pblaha@suse.cz
- now Zope works by adding  BTree class bug #7665
- work with  init account superuser bug #6258
- add redirect pages  bug #7486
* Wed May 09 2001 - pblaha@suse.cz
- add /usr/sbin/rczope
* Mon Apr 09 2001 - pblaha@suse.cz
- update on 2.3.1
* Tue Mar 27 2001 - pblaha@suse.cz
- update on 2.3.0
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Mon Jan 15 2001 - pblaha@suse.cz
- update on 2.2.5  for fix bugs
* Sat Jan 06 2001 - kukuk@suse.de
- Create start/stop links with insserv
* Tue Nov 28 2000 - ro@suse.de
- fixed startscript
* Fri Nov 24 2000 - pblaha@suse.cz
- fixed for python2.0
* Tue Nov 21 2000 - pblaha@suse.cz
- update on 2.2.2
* Sun Oct 29 2000 - kukuk@suse.de
- fix neededforbuild
* Mon Oct 09 2000 - bubnikv@suse.cz
- fixed filelist of links in /sbin/init.d/rc?.d/...
- START_ZOPE set to "no" by default
* Wed Aug 23 2000 - bubnikv@suse.cz
- new security hotfix from 2000-08-17
* Mon Jun 19 2000 - bubnikv@suse.cz
- fixed syslog patch
- added security fix from zope authors
* Fri May 12 2000 - bubnikv@suse.cz
- new package
